<script setup lang="ts">
import NavigationDrawer from '@/components/NavigationDrawer.vue'
import router from '@/router'
import { type Ref, ref, nextTick, computed } from 'vue'
import { useAuthStore } from '@/stores/auth'
import { type User } from '@/types/User'
import { type History } from '@/types/History'
import { useHistoryStore } from '@/stores/history'
import type { VForm } from 'vuetify/components'

const dialogCheckIn = ref(false)
const dialogCheckOut = ref(false)
const dialogCheckInTable = ref(false)
const dialogCheckOutTable = ref(false)
const username = ref('')
const pass = ref('')
const authStore = useAuthStore()
const historyStore = useHistoryStore()
const tab = ref(1)

const headers = [
  {
    title: 'ID',
    key: 'id',
    width: '50px'
  },
  {
    title: 'Time Date',
    key: 'timeDate',
    width: '500px'
  },
  {
    title: 'User',
    key: 'user',
    value: (item: any | History) => item.user.fullname,
    width: '350px'
  },
  {
    title: 'Late',
    key: 'late'
  },
  { title: 'Actions', key: 'actions', sortable: false }
]

const errorDialog = ref(false)

const dialogDelete = ref(false)
const loading = ref(false)
const form = ref(false)
const refform = ref<VForm | null>(null)
let editedIndex = -1

const editedHistoryCheckIn = ref<History>(JSON.parse(JSON.stringify(historyStore.defaultHistory)))
const historyCheckIn = ref<History[]>([])
historyCheckIn.value = historyStore.historyCheckIn

const editedHistoryCheckOut = ref<History>(JSON.parse(JSON.stringify(historyStore.defaultHistory)))
const historyCheckOut = ref<History[]>([])
historyCheckOut.value = historyStore.historyCheckOut

function sortByIdDescending(items: History[]) {
  return items.slice().sort((a, b) => b.id - a.id)
}

const sortedHistoryCheckIn = computed(() => sortByIdDescending(historyCheckIn.value))
const sortedHistoryCheckOut = computed(() => sortByIdDescending(historyCheckOut.value))

let lastestIdCheckIn = 1
let latestIdCheckIn = 1
historyCheckIn.value.forEach((historyCheckIn) => {
  if (historyCheckIn.id > lastestIdCheckIn) {
    latestIdCheckIn = historyCheckIn.id
  }
})
lastestIdCheckIn = latestIdCheckIn + 1

let lastestIdCheckOut = 1
let latestIdCheckOut = 1
historyCheckOut.value.forEach((historyCheckOut) => {
  if (historyCheckOut.id > lastestIdCheckOut) {
    latestIdCheckOut = historyCheckOut.id
  }
})
lastestIdCheckOut = latestIdCheckOut + 1

function CheckIn() {
  historyStore.checkCorrectIdPass(username.value, pass.value)
  if (historyStore.status === true) {
    dialogCheckIn.value = false

    historyCheckIn.value.push({
      id: lastestIdCheckIn++,
      timeDate: new Date(),
      user: authStore.currentUser!,
      late: false
    })
  } else {
    errorDialog.value = true
  }
}

function CheckOut() {
  historyStore.checkCorrectIdPass(username.value, pass.value)
  if (historyStore.status === true) {
    dialogCheckOut.value = false
    historyCheckOut.value.push({
      id: lastestIdCheckOut++,
      timeDate: new Date(),
      user: authStore.currentUser!,
      late: false
    })
  } else {
    errorDialog.value = true
  }
}

async function saveCheckIn() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(historyCheckIn.value[editedIndex], editedHistoryCheckIn.value)
    Object.assign(historyStore.historyCheckIn[editedIndex + 1], editedHistoryCheckIn.value)
  } else {
    editedHistoryCheckIn.value.id = lastestIdCheckIn++
    historyCheckIn.value.push(editedHistoryCheckIn.value)
    username.value = ''
    pass.value = ''
  }
  historyCheckIn.value = [...historyCheckIn.value]
  closeDialog()
}

async function saveCheckOut() {
  const { valid } = await refform.value!.validate()
  if (!valid) return
  if (editedIndex > -1) {
    Object.assign(historyCheckOut.value[editedIndex], editedHistoryCheckOut.value)
    Object.assign(historyStore.historyCheckOut[editedIndex + 1], editedHistoryCheckOut.value)
  } else {
    editedHistoryCheckOut.value.id = lastestIdCheckOut++
    historyCheckOut.value.push(editedHistoryCheckOut.value)
    username.value = ''
    pass.value = ''
  }
  historyCheckOut.value = [...historyCheckOut.value]
  closeDialog()
}

function closeDialog() {
  dialogCheckIn.value = false
  dialogCheckOut.value = false
  dialogCheckInTable.value = false
  dialogCheckOutTable.value = false
  nextTick(() => {
    editedHistoryCheckIn.value = Object.assign({}, historyStore.defaultHistory)
    editedHistoryCheckOut.value = Object.assign({}, historyStore.defaultHistory)
    editedIndex = -1
  })
}

function editItemCheckIn(item: History) {
  editedIndex = historyCheckIn.value.indexOf(item)
  editedHistoryCheckIn.value = Object.assign({}, item)
  dialogCheckInTable.value = true
}

function editItemCheckOut(item: History) {
  editedIndex = historyCheckOut.value.indexOf(item)
  editedHistoryCheckOut.value = Object.assign({}, item)
  dialogCheckOutTable.value = true
}

function deleteItemCheckIn(item: History) {
  editedIndex = historyCheckIn.value.indexOf(item)
  editedHistoryCheckIn.value = Object.assign({}, item)
  dialogDelete.value = true
}

function deleteItemCheckOut(item: History) {
  editedIndex = historyCheckOut.value.indexOf(item)
  editedHistoryCheckOut.value = Object.assign({}, item)
  dialogDelete.value = true
}

function onSubmit() {}

function closeDelete() {
  dialogDelete.value = false
  nextTick(() => {
    editedHistoryCheckIn.value = Object.assign({}, historyStore.defaultHistory)
    editedHistoryCheckOut.value = Object.assign({}, historyStore.defaultHistory)
  })
  editedIndex = -1
}

function deleteItemConfirm() {
  historyCheckIn.value.splice(editedIndex, 1)
  historyCheckOut.value.splice(editedIndex, 1)
  closeDelete()
}

function sortByIdAscending(items: History[]) {
  return items.slice().sort((a, b) => a.id - b.id)
}
</script>

<template>
  <v-dialog v-model="dialogDelete" width="500px">
    <v-card>
      <br />
      <v-img style="margin-left: 230px" :width="40" src="\src\assets\Login\icon.png"></v-img>
      <v-spacer></v-spacer>
      <v-card-title align="center" class="text-h5">Are you sure?</v-card-title>
      <v-card-title align="center" class="text-h10">
        This action cannot be undone.<br />
        All values associated with this field will be lost.
      </v-card-title>
      <v-spacer></v-spacer>
      <div align="center">
        <div style="margin: 0 auto; max-width: 400px">
          <v-btn
            block
            style="background-color: #e11d48"
            color="white"
            variant="text"
            @click="deleteItemConfirm()"
          >
            Delete field
          </v-btn>
        </div>
      </div>
      <div align="center">
        <div
          style="
            margin: 0 auto;
            max-width: 400px;
            border: 1px solid #dfe1e6;
            border-radius: 5px;
            margin-top: 10px;
          "
        >
          <v-btn block color="primary" variant="text" @click="closeDelete()"> Cancel </v-btn>
        </div>
      </div>
      <v-spacer></v-spacer>
      <br />
    </v-card>
  </v-dialog>

  <v-sheet style="min-width: 300px; height: 100%; elevation: 6">
    <v-tabs
      v-model="tab"
      color="deep-orange-darken-4"
      align-tabs="center"
      style="background-color: #212121; color: white"
    >
      <v-tab :value="1">Check In History</v-tab>
      <v-tab :value="2">Check Out History</v-tab>
    </v-tabs>
    <v-window v-model="tab">
      <v-window-item :value="1">
        <div>
          <v-data-table :headers="headers" :items="sortedHistoryCheckIn" height="350">
            <template v-slot:top>
              <v-toolbar flat style="background-color: #282828; color: white">
                <v-toolbar-title>Check In History</v-toolbar-title>
                <v-dialog v-model="dialogCheckInTable" persistent width="500">
                  <v-card>
                    <v-card-title>
                      <span class="text-h5">Check In History</span>
                    </v-card-title>
                    <v-card-text>
                      <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
                        <v-container>
                          <v-row>
                            <v-col cols="12" sm="12" md="12">
                              <v-text-field
                                v-model="editedHistoryCheckIn.timeDate"
                                :rules="[(v) => !!v || 'Plaese fill data']"
                                :readonly="loading"
                                class="mb-2"
                                clearable
                                label="Time Date"
                              ></v-text-field>
                            </v-col>

                            <v-col cols="12" sm="12" md="12">
                              <v-combobox
                                v-model="editedHistoryCheckIn.late"
                                :readonly="loading"
                                :items="[
                                  { title: 'True', value: true },
                                  { title: 'False', value: false }
                                ]"
                                label="Select Late Status"
                                :return-object="false"
                              ></v-combobox>
                            </v-col>
                          </v-row>
                        </v-container>
                      </v-form>
                      <small style="color: red">*Plaese fill data</small>
                    </v-card-text>
                    <v-card-actions>
                      <v-spacer></v-spacer>
                      <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">
                        Close
                      </v-btn>
                      <v-btn color="blue-darken-1" variant="text" @click="saveCheckIn()">
                        Save
                      </v-btn>
                    </v-card-actions>
                  </v-card>
                </v-dialog>
              </v-toolbar>
            </template>
            <template v-slot:[`item.actions`]="{ item }">
              <v-icon
                size="small"
                class="me-2"
                v-model="dialogCheckInTable"
                @click="editItemCheckIn(item)"
              >
                mdi-pencil
              </v-icon>
              <v-icon size="small" v-model="dialogDelete" @click="deleteItemCheckIn(item)">
                mdi-delete
              </v-icon>
            </template>
          </v-data-table>
        </div>
      </v-window-item>
      <v-window-item :value="2">
        <div>
          <v-data-table :headers="headers" :items="sortedHistoryCheckOut" height="350">
            <template v-slot:top>
              <v-toolbar flat style="background-color: #282828; color: white">
                <v-toolbar-title>Check Out History</v-toolbar-title>
                <v-dialog v-model="dialogCheckOutTable" persistent width="500">
                  <v-card>
                    <v-card-title>
                      <span class="text-h5">Check Out History</span>
                    </v-card-title>
                    <v-card-text>
                      <v-form ref="refform" v-model="form" @submit.prevent="onSubmit">
                        <v-container>
                          <v-row>
                            <v-col cols="12" sm="12" md="12">
                              <v-text-field
                                v-model="editedHistoryCheckOut.timeDate"
                                :readonly="loading"
                                :rules="[(v) => !!v || 'Plaese fill data']"
                                class="mb-2"
                                clearable
                                label="Time Date"
                              ></v-text-field>
                            </v-col>

                            <v-col cols="12" sm="12" md="12">
                              <v-combobox
                                v-model="editedHistoryCheckOut.late"
                                :readonly="loading"
                                :items="[
                                  { title: 'True', value: true },
                                  { title: 'False', value: false }
                                ]"
                                label="Select Late Status"
                                :return-object="false"
                              ></v-combobox>
                            </v-col>
                          </v-row>
                        </v-container>
                      </v-form>
                      <small style="color: red">*Plaese fill data</small>
                    </v-card-text>
                    <v-card-actions>
                      <v-spacer></v-spacer>
                      <v-btn color="blue-darken-1" variant="text" @click="closeDialog()">
                        Close
                      </v-btn>
                      <v-btn color="blue-darken-1" variant="text" @click="saveCheckOut()">
                        Save
                      </v-btn>
                    </v-card-actions>
                  </v-card>
                </v-dialog>
              </v-toolbar>
            </template>
            <template v-slot:[`item.actions`]="{ item }">
              <v-icon
                size="small"
                class="me-2"
                v-model="dialogCheckOutTable"
                @click="editItemCheckOut(item)"
              >
                mdi-pencil
              </v-icon>
              <v-icon size="small" v-model="dialogDelete" @click="deleteItemCheckOut(item)">
                mdi-delete
              </v-icon>
            </template>
          </v-data-table>
        </div>
      </v-window-item>
    </v-window>
  </v-sheet>

  <div class="justify-center">
    <v-dialog name="Check In Btn" v-model="dialogCheckIn" persistent width="450">
      <template v-slot:activator="{ props }">
        <v-btn
          v-bind="props"
          height="40px"
          width="150px"
          style="margin-left: 30%; margin-top: 50px; background-color: #c7a17a; color: white"
        >
          Check In
        </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">Check In</span>
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12" md="13" class="mx-auto">
                <v-text-field
                  label="Username"
                  required
                  variant="outlined"
                  prepend-inner-icon="mdi-account"
                  v-model="username"
                ></v-text-field>
              </v-col>
              <v-col cols="12" md="13" class="mx-auto">
                <v-text-field
                  label="Password"
                  type="password"
                  required
                  variant="outlined"
                  prepend-inner-icon="mdi-lock-outline"
                  v-model="pass"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
          <small class="text-caption text-decoration-none text-blue"
            >Please enter your password.</small
          >
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" variant="text" @click="dialogCheckIn = false"> Close </v-btn>
          <v-btn color="primary" variant="text" @click="CheckIn()"> Login </v-btn>

          <v-dialog v-model="errorDialog" width="500px">
            <v-card>
              <br />
              <v-img
                style="margin-left: 230px"
                :width="40"
                src="\src\assets\Login\icon.png"
              ></v-img>
              <v-spacer></v-spacer>
              <v-card-title align="center" class="text-h5">Check In Failed</v-card-title>
              <v-card-title align="center" class="text-h10">
                This action cannot be undone.<br />
                You need to put correct password.
              </v-card-title>
              <v-spacer></v-spacer>
              <div align="center">
                <div
                  style="
                    margin: 0 auto;
                    max-width: 400px;
                    border: 1px solid #dfe1e6;
                    border-radius: 5px;
                    margin-top: 10px;
                  "
                >
                  <v-btn block color="primary" variant="text" @click="errorDialog = false">
                    Cancel
                  </v-btn>
                </div>
              </div>
              <v-spacer></v-spacer>
              <br />
            </v-card>
          </v-dialog>
        </v-card-actions>
      </v-card>
    </v-dialog>

    <v-dialog name="CheckOut Btn" v-model="dialogCheckOut" persistent width="450">
      <template v-slot:activator="{ props }">
        <v-btn
          v-bind="props"
          height="40px"
          width="150px"
          style="margin-left: 20%; margin-top: 50px; background-color: #97724a; color: white"
        >
          Check Out
        </v-btn>
      </template>
      <v-card>
        <v-card-title>
          <span class="text-h5">Check Out</span>
        </v-card-title>
        <v-card-text>
          <v-container>
            <v-row>
              <v-col cols="12" md="13" class="mx-auto">
                <v-text-field
                  label="Username"
                  required
                  variant="outlined"
                  prepend-inner-icon="mdi-account"
                  v-model="username"
                ></v-text-field>
              </v-col>
              <v-col cols="12" md="13" class="mx-auto">
                <v-text-field
                  label="Password"
                  type="password"
                  required
                  variant="outlined"
                  prepend-inner-icon="mdi-lock-outline"
                  v-model="pass"
                ></v-text-field>
              </v-col>
            </v-row>
          </v-container>
          <small class="text-caption text-decoration-none text-blue"
            >Please enter your password.</small
          >
        </v-card-text>
        <v-card-actions>
          <v-spacer></v-spacer>
          <v-btn color="primary" variant="text" @click="dialogCheckOut = false"> Close </v-btn>
          <v-btn color="primary" variant="text" @click="CheckOut()"> Login </v-btn>

          <v-dialog v-model="errorDialog" width="500px">
            <v-card>
              <br />
              <v-img
                style="margin-left: 230px"
                :width="40"
                src="\src\assets\Login\icon.png"
              ></v-img>
              <v-spacer></v-spacer>
              <v-card-title align="center" class="text-h5">Check Out Failed</v-card-title>
              <v-card-title align="center" class="text-h10">
                This action cannot be undone.<br />
                You need to put correct password.
              </v-card-title>
              <v-spacer></v-spacer>
              <div align="center">
                <div
                  style="
                    margin: 0 auto;
                    max-width: 400px;
                    border: 1px solid #dfe1e6;
                    border-radius: 5px;
                    margin-top: 10px;
                  "
                >
                  <v-btn block color="primary" variant="text" @click="errorDialog = false">
                    Cancel
                  </v-btn>
                </div>
              </div>
              <v-spacer></v-spacer>
              <br />
            </v-card>
          </v-dialog>
        </v-card-actions>
      </v-card>
    </v-dialog>
  </div>

  <br /><br />
</template>

<style scoped></style>
